function [Zsol,UtZsol] = twosided_squareLoss_dual_get_Z(U, lambda, I, J, Y, mask, B, options)
Ut = U';
rhs = Y;

% Call PCG
[Zsol, ~, relres, iter] = pcg(@compute_matrix_system, rhs, options.innerpcgtol, options.innerpcgmaxiter); % 

    function lhsx = compute_matrix_system(x)
        UtX = mymultfullsparse(Ut, x, mask); % |Omega| operations. Mex code heavy.
        UtXBt = UtX*B';
        UtXBtB = full(UtXBt*B);
        lhsx = x/(2*lambda) + myspmaskmult(U', UtXBtB, I, J);     
    end
UtZsol = mymultfullsparse(Ut, Zsol, mask);
end